import React from 'react';
import { MaterialProps, ReactThreeFiber, MeshStandardMaterialProps, MeshPhysicalMaterialProps, MeshPhongMaterialProps } from '@react-three/fiber';
import CSM from './vanilla';
import { iCSMProps } from './types';
declare type iCSMAllProps = iCSMProps & MaterialProps & MeshPhysicalMaterialProps & MeshStandardMaterialProps & MeshPhongMaterialProps & {
    alphaWrite?: unknown;
};
declare global {
    namespace JSX {
        interface IntrinsicElements {
            customShaderMaterial: ReactThreeFiber.Object3DNode<CSM, typeof CSM>;
        }
    }
}
declare const _default: React.ForwardRefExoticComponent<Pick<iCSMAllProps, "baseMaterial" | "fragmentShader" | "vertexShader" | "uniforms" | "alphaTest" | "alphaToCoverage" | "alphaWrite" | "blendDst" | "blendDstAlpha" | "blendEquation" | "blendEquationAlpha" | "blending" | "blendSrc" | "blendSrcAlpha" | "clipIntersection" | "clippingPlanes" | "clipShadows" | "colorWrite" | "defines" | "depthFunc" | "depthTest" | "depthWrite" | "fog" | "id" | "stencilWrite" | "stencilFunc" | "stencilRef" | "stencilWriteMask" | "stencilFuncMask" | "stencilFail" | "stencilZFail" | "stencilZPass" | "isMaterial" | "name" | "needsUpdate" | "opacity" | "polygonOffset" | "polygonOffsetFactor" | "polygonOffsetUnits" | "precision" | "premultipliedAlpha" | "dithering" | "side" | "shadowSide" | "toneMapped" | "transparent" | "type" | "uuid" | "vertexColors" | "visible" | "userData" | "version" | "clone" | "copy" | "dispose" | "onBeforeCompile" | "customProgramCacheKey" | "setValues" | "toJSON" | "addEventListener" | "hasEventListener" | "removeEventListener" | "dispatchEvent" | "attach" | "attachArray" | "attachObject" | "attachFns" | "args" | "children" | "key" | "onUpdate" | "clearcoat" | "clearcoatMap" | "clearcoatRoughness" | "clearcoatRoughnessMap" | "clearcoatNormalScale" | "clearcoatNormalMap" | "reflectivity" | "ior" | "sheen" | "sheenColor" | "sheenColorMap" | "sheenRoughness" | "sheenRoughnessMap" | "transmission" | "transmissionMap" | "thickness" | "thicknessMap" | "attenuationDistance" | "attenuationColor" | "specularIntensity" | "specularColor" | "specularIntensityMap" | "specularColorMap" | "color" | "roughness" | "metalness" | "map" | "lightMap" | "lightMapIntensity" | "aoMap" | "aoMapIntensity" | "emissive" | "emissiveIntensity" | "emissiveMap" | "bumpMap" | "bumpScale" | "normalMap" | "normalMapType" | "normalScale" | "displacementMap" | "displacementScale" | "displacementBias" | "roughnessMap" | "metalnessMap" | "alphaMap" | "envMap" | "envMapIntensity" | "refractionRatio" | "wireframe" | "wireframeLinewidth" | "wireframeLinecap" | "wireframeLinejoin" | "flatShading" | "isMeshStandardMaterial" | "specular" | "shininess" | "specularMap" | "combine" | "metal"> & React.RefAttributes<CSM>>;
export default _default;
